## davix 0.7.5

=== CMakeLists.txt ===
#-------------------------------------------------------------------------------
# Initialize
#-------------------------------------------------------------------------------
project (davix)
cmake_minimum_required (VERSION 2.8.11)
set(CMAKE_DISABLE_IN_SOURCE_BUILD ON)

#-------------------------------------------------------------------------------
# Find the python executable to use during the build
#-------------------------------------------------------------------------------
find_package(PythonInterp REQUIRED)

#-------------------------------------------------------------------------------
# Regenerate include/davix/features.hpp and version.cmake at _build_ time
#-------------------------------------------------------------------------------
add_custom_target(GenerateVersionInfo ALL DEPENDS Version)
add_custom_command(
  OUTPUT Version
  COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/genversion.py --template include/davix/features.hpp.in --out include/davix/features.hpp
  COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/genversion.py --template version.cmake.in --out version.cmake
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

#-------------------------------------------------------------------------------
# Regenerate version.cmake at _configure_ time. Important since the above
# only regenerates it at compile time.
#-------------------------------------------------------------------------------
execute_process(
  COMMAND ${PYTHON_EXECUTABLE} ${CMAKE_CURRENT_SOURCE_DIR}/genversion.py --template version.cmake.in --out version.cmake
  WORKING_DIRECTORY ${CMAKE_CURRENT_SOURCE_DIR}
)

#-------------------------------------------------------------------------------
# Include version.cmake. Whenever the version changes, ie you commit or tag,
# the following happens:
# - Next time you run 'make', version.cmake is updated.
# - The next 'make' will detect version.cmake was changed, and cmake will
#   reconfigure itself.
#
# A bit hacky.
#-------------------------------------------------------------------------------
include(${CMAKE_CURRENT_SOURCE_DIR}/release.cmake REQUIRED)
include(${CMAKE_CURRENT_SOURCE_DIR}/version.cmake)
message("Configuring cmake for davix version: ${VERSION_FULL}")

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")
option(SHARED_LIBRARY "generate shared library" TRUE)
option(STATIC_LIBRARY  "generate static library" FALSE)


# build type
if(NOT CMAKE_BUILD_TYPE)
    message(STATUS "No build type selected, default to RelWithDebInfo")
    set(CMAKE_BUILD_TYPE "RelWithDebInfo")
endif(NOT CMAKE_BUILD_TYPE)

# load module
include(DefineInstallationPaths REQUIRED)
include(ReleaseDebugAutoFlags REQUIRED)
include(CMakeGeneratePkgConfig REQUIRED)
include(MacroAddDoxygen REQUIRED)
include(CMakeCXX11Support REQUIRED)
include(PortabilityGNUCheck REQUIRED)

#enable testing
INCLUDE(CTest)


set(OUTPUT_NAME_DAVIX "davix")

# components
option(ENABLE_TOOLS "enable or disable tools " TRUE)
option(ENABLE_HTML_DOCS "enable or disable generation of HTML documentation" FALSE)

# features
option(ENABLE_IPV6 "enable or disable IPv6 support " TRUE)
option(ENABLE_TCP_NODELAY "enable or disable tcp_nodelay" TRUE)
option(ENABLE_THIRD_PARTY_COPY "enable or disable third party copy support" FALSE)

# tests
option(BENCH_TESTS "enable or disable the bench tests" FALSE)
option(DAVIX_TESTS "Flag to disable the building of all tests" TRUE)

# libs checks
find_package(Threads)

# openssl
find_package(OpenSSL)
SET(LIBSSL_PKG_LIBRARIES "${OPENSSL_LIBRARIES}")
SET(CRYPTO_PKG "")
SET(LIBSSL_PKG_INCLUDE_DIRS "${OPENSSL_INCLUDE_DIR}")

find_package(LibXml2)
set(LIBXML2_INCLUDE_DIRS ${LIBXML2_INCLUDE_DIR})

#const
set(HAVE_OPENSSL 1)
set(NE_HAVE_SSL 1)

add_subdirectory(deps)


#libuuid
find_package(uuid)


## general defs
add_definitions( -D_GNU_SOURCE)              # GNU source, import LFS, etc...
add_definitions( -D__DAVIX_INSIDE__)         # protection flag
add_definitions( -D__STDC_LIMIT_MACROS )     # C99 limit macros


set(CMAKE_CXX_FLAGS "${CMAKE_CXX_FLAGS} ${CXX11_FLAG_ENABLE}")

include_directories( ${HTTPLIB_PKG_INCLUDE_DIRS} ${GLIB2_PKG_INCLUDE_DIRS} ${CMAKE_CURRENT_SOURCE_DIR}/deps ${CMAKE_CURRENT_SOURCE_DIR}/deps/libneon/src/ ${UUID_INCLUDE_DIRS} )
include_directories( ${CMAKE_SOURCE_DIR}/include/davix )
include_directories( ${CMAKE_SOURCE_DIR}/src/libs/)

add_subdirectory (src)
add_subdirectory (doc)

if(EXISTS "${CMAKE_SOURCE_DIR}/dist/CMakeLists.txt")
  add_subdirectory (dist)
endif()

if(DAVIX_TESTS)
  add_subdirectory (test)
endif()

#############################################################################
## headers
configure_file("${CMAKE_SOURCE_DIR}/include/davix/features.hpp.in"
               "${CMAKE_SOURCE_DIR}/include/davix/features.hpp"
               @ONLY)

install(DIRECTORY ${CMAKE_SOURCE_DIR}/include/davix/
        DESTINATION ${INCLUDE_INSTALL_DIR}/davix
        PATTERN "*.in" EXCLUDE)

##############################################################################
## Doc file
install(FILES RELEASE-NOTES.md LICENSE
                DESTINATION ${DOC_INSTALL_DIR}/) # install release notes


#######################################################
# Configure an 'uninstall' target
CONFIGURE_FILE(
  "${CMAKE_CURRENT_SOURCE_DIR}/cmake_uninstall.cmake.in"
  "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake"
  IMMEDIATE @ONLY)

ADD_CUSTOM_TARGET(uninstall
  "${CMAKE_COMMAND}" -P "${CMAKE_CURRENT_BINARY_DIR}/cmake_uninstall.cmake")

=== doc/CMakeLists.txt ===



file(MAKE_DIRECTORY "${CMAKE_CURRENT_BINARY_DIR}/build/html/")

if(ENABLE_HTML_DOCS)
  addDoxyGeneration("Doxyfile.in")
  add_custom_target(doc DEPENDS)
  add_dependencies(doc doxygen)

  SET( l_doc "${CMAKE_CURRENT_BINARY_DIR}/build/html/")

  find_package(Sphinx)
  if(SPHINX_FOUND)
    add_custom_target(sphinx
      DEPENDS doxygen
      COMMAND ${SPHINX_EXECUTABLE}
      -q -b html
      "${CMAKE_CURRENT_SOURCE_DIR}/sphinx"
      "${l_doc}/")

    add_dependencies(doc sphinx)
  endif(SPHINX_FOUND)

  install(DIRECTORY ${l_doc} DESTINATION ${DOC_INSTALL_DIR}/html)
endif(ENABLE_HTML_DOCS)

FILE(GLOB man1_page ${CMAKE_CURRENT_SOURCE_DIR}/man/*.1)
install(FILES ${man1_page}
                        DESTINATION ${MAN_INSTALL_DIR}/man1/)

FILE(GLOB man3_page ${CMAKE_CURRENT_SOURCE_DIR}/man/*.3)
install(FILES ${man3_page}
                        DESTINATION ${MAN_INSTALL_DIR}/man3/)

=== test/CMakeLists.txt ===
# main file for src

# force RPATH usage for easy test execution
set(CMAKE_SKIP_RPATH OFF
    CACHE BOOL "" FORCE)


include_directories(${PROJECT_SOURCE_DIR}/src ${PROJECT_BINARY_DIR}/src/)
link_directories(${PROJECT_BINARY_DIR}/src/)


set(TEST_CRED_PATH "${CMAKE_CURRENT_SOURCE_DIR}/certs/my_keycert.p12")
set(TEST_CRED_PASS "testpass")

add_subdirectory(unit)
add_subdirectory(functional)
add_subdirectory(root-tests)
add_subdirectory(bench)

=== src/tools/CMakeLists.txt ===
# main file for command line tools
#




LIST(APPEND davix_main_src "davix_tool_main.cpp")
LIST(APPEND davix_ls_main_src "davix_tool_ls_main.cpp")
LIST(APPEND davix_get_main_src "davix_tool_get_main.cpp")
LIST(APPEND davix_put_main_src "davix_tool_put_main.cpp")
LIST(APPEND davix_rm_main_src "davix_tool_rm_main.cpp")
LIST(APPEND davix_mkcol_main_src "davix_tool_mkcol_main.cpp")
LIST(APPEND davix_mv_main_src "davix_tool_mv_main.cpp")
LIST(APPEND davix_copy_main_src "davix_tool_copy_main.cpp")
LIST(APPEND davix_tool_common_src "${CMAKE_CURRENT_SOURCE_DIR}/davix_tool_params.cpp"
                                  "${CMAKE_CURRENT_SOURCE_DIR}/davix_tool_util.cpp"
                                  "${SRC_SIMPLE_GET_PASS}"
                                  "${CMAKE_CURRENT_SOURCE_DIR}/davix_op.cpp"
                                  "${CMAKE_CURRENT_SOURCE_DIR}/davix_taskqueue.cpp"
                                  "${CMAKE_CURRENT_SOURCE_DIR}/davix_thread.cpp"
                                  "${CMAKE_CURRENT_SOURCE_DIR}/davix_thread_pool.cpp"
                                  "${CMAKE_CURRENT_SOURCE_DIR}/davix_config_parser.cpp")
SET(davix_tool_common_src_up "${davix_tool_common_src}" PARENT_SCOPE)

link_directories(${PROJECT_BINARY_DIR}/src/)


## davix tool lib
add_library(davix_tool_lib STATIC ${davix_tool_common_src})


## davix cmd line
add_executable(davix_tool ${davix_main_src})

target_link_libraries(davix_tool davix_tool_lib libdavix)
set_target_properties(davix_tool PROPERTIES
                                OUTPUT_NAME "davix-http")

## davix ls cmd line
add_executable(davix_ls_tool ${davix_ls_main_src})

target_link_libraries(davix_ls_tool davix_tool_lib libdavix ${CMAKE_THREAD_LIBS_INIT})
set_target_properties(davix_ls_tool PROPERTIES
                                OUTPUT_NAME "davix-ls")


## davix get cmd line
add_executable(davix_get_tool ${davix_get_main_src})

target_link_libraries(davix_get_tool davix_tool_lib libdavix pthread ${CMAKE_THREAD_LIBS_INIT})
set_target_properties(davix_get_tool PROPERTIES
                                OUTPUT_NAME "davix-get")

## davix put cmd line
add_executable(davix_put_tool ${davix_put_main_src})

target_link_libraries(davix_put_tool davix_tool_lib libdavix pthread ${CMAKE_THREAD_LIBS_INIT})
set_target_properties(davix_put_tool PROPERTIES
                                OUTPUT_NAME "davix-put")


## davix del cmd line
add_executable(davix_mkdir_tool ${davix_mkcol_main_src})

target_link_libraries(davix_mkdir_tool davix_tool_lib libdavix)
set_target_properties(davix_mkdir_tool PROPERTIES
                                OUTPUT_NAME "davix-mkdir")

## davix rm cmd line
add_executable(davix_rm_tool ${davix_rm_main_src})

target_link_libraries(davix_rm_tool davix_tool_lib libdavix ${CMAKE_THREAD_LIBS_INIT})
set_target_properties(davix_rm_tool PROPERTIES
                                OUTPUT_NAME "davix-rm")

## davix mv cmd line
add_executable(davix_mv_tool ${davix_mv_main_src})

target_link_libraries(davix_mv_tool davix_tool_lib libdavix)
set_target_properties(davix_mv_tool PROPERTIES
                                OUTPUT_NAME "davix-mv")



install(TARGETS davix_tool davix_ls_tool davix_get_tool davix_put_tool davix_mkdir_tool davix_rm_tool davix_mv_tool
         DESTINATION ${BIN_INSTALL_DIR}/)

## davix cp cmd line
if (ENABLE_THIRD_PARTY_COPY)

    add_executable(davix_cp_tool ${davix_copy_main_src})

    target_link_libraries(davix_cp_tool davix_copy davix_tool_lib)
    set_target_properties(davix_cp_tool PROPERTIES
                                OUTPUT_NAME "davix-cp")
    add_dependencies(davix_cp_tool davix_copy)

    install(TARGETS davix_cp_tool
            DESTINATION ${BIN_INSTALL_DIR}/)

endif (ENABLE_THIRD_PARTY_COPY)

=== test/functional/CMakeLists.txt ===
# main file for src


set(src_davix_test_lib "davix_test_lib.cpp")

#set( src_test_req "test_request.cpp")
#set( src_test_checksum "test_checksum.cpp")
#set( src_test_stat_session "test_stat_session.cpp")
#set( src_test_rw "davix_rw_test.cpp")
#set( src_test_opendir "test_opendir.cpp")
#set( src_test_opendir_partial "test_opendir_partial.cpp")
#set( src_test_opendirpp "test_opendirpp.cpp")
#set( src_test_directory "test_directory.cpp")
#set( src_test_auto_stat_mkdir_check "test_auto_stat_mkdir_check.cpp")
#set( src_test_auto_rmdir_unlink_delete "test_auto_rmdir_unlink_delete.cpp")
#set( src_test_valid_read_generic_simple "test_valid_read_generic_simple.cpp")
#set( src_test_valid_write_read_generic_simple "test_valid_write_read_generic_simple.cpp")
#set( src_test_valid_write_read_fd "test_valid_write_read_fd.cpp")
#set( src_test_valid_write_read_vector_simple "test_valid_write_read_vector_simple.cpp")
#set( src_tool_read_vector_simple "tool_read_vector_simple.cpp")
#set( src_tool_get_replicas "tool_get_replica_simple.cpp")
#set( src_test_mv "test_mv.cpp")

set( src_tester "davix-tester.cpp")


add_library(test_davix_functional_lib STATIC ${src_davix_test_lib})

#add_executable(test_request ${src_test_req} )
#target_link_libraries(test_request libdavix  test_davix_functional_lib)

#add_executable(tool_read_vector_simple ${src_tool_read_vector_simple} )
#target_link_libraries(tool_read_vector_simple libdavix test_davix_functional_lib )

#add_executable(test_rw_fd ${src_test_valid_write_read_fd})
#target_link_libraries(test_rw_fd libdavix test_davix_functional_lib )

#add_executable(test_stat_auto_check ${src_test_auto_stat_mkdir_check})
#target_link_libraries(test_stat_auto_check libdavix test_davix_functional_lib)

#add_executable(test_checksum ${src_test_checksum})
#target_link_libraries(test_checksum libdavix test_davix_functional_lib)

#add_executable(test_auto_rmdir_unlink_delete ${src_test_auto_rmdir_unlink_delete})
#target_link_libraries(test_auto_rmdir_unlink_delete libdavix test_davix_functional_lib)

#add_executable(test_stat_session ${src_test_stat_session})
#target_link_libraries(test_stat_session libdavix test_davix_functional_lib)


#add_executable(test_rw ${src_test_rw})
#target_link_libraries(test_rw libdavix test_davix_functional_lib)

#add_executable(test_opendir ${src_test_opendir} )
#target_link_libraries(test_opendir libdavix test_davix_functional_lib)


#add_executable(test_directory ${src_test_directory} )
#target_link_libraries(test_directory libdavix test_davix_functional_lib)

#add_executable(test_opendir_partial ${src_test_opendir_partial})
#target_link_libraries(test_opendir_partial libdavix test_davix_functional_lib)

#add_executable(test_opendirpp ${src_test_opendirpp})
#target_link_libraries(test_opendirpp libdavix test_davix_functional_lib)

#add_executable(test_valid_read_generic_simple ${src_test_valid_read_generic_simple})
#target_link_libraries(test_valid_read_generic_simple libdavix test_davix_functional_lib)

#add_executable(test_valid_write_read_generic_simple ${src_test_valid_write_read_generic_simple})
#target_link_libraries(test_valid_write_read_generic_simple libdavix test_davix_functional_lib)

#add_executable(test_valid_write_read_vector_simple ${src_test_valid_write_read_vector_simple})
#target_link_libraries(test_valid_write_read_vector_simple libdavix test_davix_functional_lib)


#add_executable(tool_get_replicas ${src_tool_get_replicas})
#target_link_libraries(tool_get_replicas libdavix test_davix_functional_lib)

#add_executable(test_mv ${src_test_mv})
#target_link_libraries(test_mv libdavix test_davix_functional_lib)

add_executable(davix-tester ${src_tester})
target_link_libraries(davix-tester libdavix test_davix_functional_lib)

install(TARGETS davix-tester
  DESTINATION ${BIN_INSTALL_DIR}/)

function(assert_not_empty var)
    if("${var}" STREQUAL "")
        message(FATAL_ERROR "variable must not be empty")
    endif()
endfunction(assert_not_empty)

function(matchparam param input)
    set(normalchars "a-zA-Z0-9/:.,")
    string(REGEX MATCH "${param} +(([${normalchars}]-| |[${normalchars}])+)" tmp ${input})
    if(NOT "${tmp}" STREQUAL "")
        string(REPLACE " " "" stripped ${CMAKE_MATCH_1})
        set(match ${stripped} PARENT_SCOPE)
    else()
        set(match "" PARENT_SCOPE)
    endif()
endfunction(matchparam)

function(paramexists param input)
    string(REGEX MATCH "${param}" tmp ${input})
    set(match ${tmp} PARENT_SCOPE)
endfunction(paramexists)

function(runtest params cmd)
    matchparam("--auth" ${params})
    set(auth ${match})
    assert_not_empty(${auth})

    matchparam("--uri" ${params})
    set(uri ${match})
    assert_not_empty(${uri})

    matchparam("--s3region" ${params})
    set(s3region ${match})

    paramexists("--s3alternate" ${params})
    set(s3alternate ${match})

    # build testname
    set(testname "${auth}")

    if(NOT "${s3region}" STREQUAL "")
        set(testname "${testname}|v4")
    endif()

    if(NOT "${s3alternate}" STREQUAL "")
        set(testname "${testname}|alt")
    endif()

    string(REPLACE " " "" cmdname ${cmd})
    set(testname "${testname}|${cmdname}|${uri}")

    set(arguments ${params})
    separate_arguments(arguments)
    add_test(${testname} davix-tester ${arguments} "--command" "${cmd}")
endfunction(runtest)

function(preadvectest_single params ranges)
    runtest("${params}" "preadvec ${ranges} mergewindow=1")
    runtest("${params}" "preadvec ${ranges} mergewindow=1000")
    runtest("${params}" "preadvec ${ranges} nomulti,mergewindow=1000")
    runtest("${params}" "preadvec ${ranges} nomulti,mergewindow=1")
endfunction(preadvectest_single)

function(preadvectest params)
    preadvectest_single("${params}" "0-10,5-10,3-4,30-40,200-305,1000-1500")
    preadvectest_single("${params}" "0-10,5-10")
    preadvectest_single("${params}" "0-10,15-20")
endfunction(preadvectest)

function(fulltest params)
    runtest("${params}" "makeCollection")
    runtest("${params}" "populate 5")
    runtest("${params}" "listing 5")
    preadvectest("${params}")
    runtest("${params}" "movefile")
    runtest("${params}" "depopulate 3")
    runtest("${params}" "countfiles 2")
    runtest("${params}" "remove")
endfunction(fulltest)

function(s3tests params)
    runtest("${params}" "makeCollection")
    runtest("${params}" "populate 5")
    runtest("${params}" "listing 5")
    preadvectest("${params}")
    runtest("${params}" "movefile")
    runtest("${params}" "depopulate 3")
    runtest("${params}" "countfiles 2")
    runtest("${params}" "depopulate 5")
endfunction(s3tests)

function(test_with_proxy uri)
    fulltest("--auth proxy --uri ${uri}")
endfunction(test_with_proxy)

function(test_s3 accesskey secretkey uri region use_alt)
    set(params "--auth aws --s3accesskey ${accesskey} --s3secretkey ${secretkey} --uri ${uri}")
    if(NOT "${region}" STREQUAL "")
        set(params "${params} --s3region ${region}")
    endif()

    if(use_alt MATCHES "^alt$")
        set(params "${params} --s3alternate")
    elseif(NOT use_alt MATCHES "^noalt$")
        message(FATAL_ERROR "Invalid option passed to test_s3 for use_alt: ${use_alt}")
    endif()

    s3tests(${params})
endfunction(test_s3)

function(test_azure azurekey uri)
    set(params "--auth azure --azurekey ${azurekey} --uri ${uri}")

    runtest("${params}" "populate 5")
    runtest("${params}" "statdir")
    runtest("${params}" "listing 5")
    preadvectest("${params}")
    runtest("${params}" "depopulate 5")
endfunction(test_azure)


include(${CMAKE_SOURCE_DIR}/credentials/creds.cmake OPTIONAL)


### DEPRECATED, to remove soon

# function(test_dav_endpoint_ronly name cred)

#     add_test(test_stat_session_${name} test_stat_session ${cred} ${name} ${name} ${name} ${name} ${name} ${name} ${name})
#     add_test(test_opendir_${name} test_opendir ${name} ${cred})
#   #  add_test(test_opendir_c_${name} test_opendir_c ${name} ${cred})
#     add_test(test_opendirpp_${name} test_opendirpp ${name} ${cred})
#   #  add_test(test_stat_c_${name} test_stat_c ${name} ${cred})
# endfunction(test_dav_endpoint_ronly name cred)

# function(test_dav_endpoint_rw name cred)

#     add_test(test_stat_session_${name} test_stat_session ${cred} ${name} ${name} ${name} ${name} ${name} ${name} ${name})
#     add_test(test_opendir_${name} test_opendir ${name} ${cred})
#     add_test(test_opendirpp_${name} test_opendirpp ${name} ${cred})
#     add_test(test_stat_auto_check_${name} test_stat_auto_check ${name} ${cred})
# endfunction(test_dav_endpoint_rw name cred)

# function(listdir_partial name size cred)
#     add_test(test_opendir_partial_${name}  test_opendir_partial ${name} ${size} ${cred})
# endfunction(listdir_partial name size cred)


# function(test_collection name cred)
#     add_test(test_directory_${name} test_directory ${name} ${cred})
# endfunction(test_collection name cred)

# function(test_valid_read_generic url cred)
#     add_test(test_valid_read_generic_${url} test_valid_read_generic_simple ${url} ${cred})
# endfunction(test_valid_read_generic url cred)

# function(test_valid_delete_all url cred)
#     add_test(test_auto_rmdir_unlink_delete_${url} test_auto_rmdir_unlink_delete ${url} ${cred})
# endfunction(test_valid_delete_all url cred)


# function(test_valid_write_read_generic url cred)
#     add_test(test_valid_write_read_generic_simple_${url} test_valid_write_read_generic_simple ${url} ${cred})
#     add_test(test_rw_fd_${url} test_rw_fd ${url} ${cred})
#     add_test(test_valid_write_read_vector_simple_${url} test_valid_write_read_vector_simple ${url} ${cred})
# endfunction(test_valid_write_read_generic url cred)

# function(test_replica_listing_existing url cred)
#    add_test(tool_get_replicas_${url} tool_get_replicas ${url} ${cred})
# endfunction(test_replica_listing_existing url cred)

# function(test_rename url cred)
#     add_test(test_mv_${url} test_mv ${url} ${cred})
# endfunction(test_rename url cred)

=== test/unit/CMakeLists.txt ===
#-------------------------------------------------------------------------------
# Make gtest / gmock available for all targets that need it
#-------------------------------------------------------------------------------
set(BUILD_SHARED_LIBS OFF)

set(GTEST "${CMAKE_SOURCE_DIR}/deps/googletest/googletest/")
set(GTEST_BINARY_DIR "${CMAKE_BINARY_DIR}/deps/googletest/googletest/")
add_subdirectory("${GTEST}" "${GTEST_BINARY_DIR}")

include_directories(
  ${PROJECT_SOURCE_DIR}/src
  ${CMAKE_CURRENT_SOURCE_DIR}
  ${GTEST}/include
)

add_definitions( -DTEST_VALID_CERT="${TEST_CRED_PATH}" -DTEST_VALID_CERT_PASS="${TEST_CRED_PASS}")

add_executable(davix-unit-tests
  cache.cpp
  chrono.cpp
  config-parser.cpp
  context.cpp
  datetime.cpp
  digest-extractor.cpp
  gcloud.cpp
  metalink-replica.cpp
  neon.cpp
  parser.cpp
  session-factory.cpp
  session.cpp
  testcert.cpp
  typeconv.cpp
  utils.cpp
  xml-parser.cpp

  ${SRC_HMACSHA1} ${src_files} ${src_alibxx}
)

target_link_libraries(davix-unit-tests
  alibxx_core
  davix_tool_lib
  libdavix
  gtest_main
  ${CMAKE_THREAD_LIBS_INIT}
  ${LIBSSL_PKG_LIBRARIES}
)

install(TARGETS davix-unit-tests
  DESTINATION ${BIN_INSTALL_DIR}/)

add_test(unit-tests davix-unit-tests)

=== deps/googletest/googlemock/CMakeLists.txt ===
########################################################################
# CMake build script for Google Mock.
#
# To run the tests for Google Mock itself on Linux, use 'make test' or
# ctest.  You can select which tests to run using 'ctest -R regex'.
# For more options, run 'ctest --help'.

# BUILD_SHARED_LIBS is a standard CMake variable, but we declare it here to
# make it prominent in the GUI.
option(BUILD_SHARED_LIBS "Build shared libraries (DLLs)." OFF)

option(gmock_build_tests "Build all of Google Mock's own tests." OFF)

# A directory to find Google Test sources.
if (EXISTS "${CMAKE_CURRENT_SOURCE_DIR}/gtest/CMakeLists.txt")
  set(gtest_dir gtest)
else()
  set(gtest_dir ../googletest)
endif()

# Defines pre_project_set_up_hermetic_build() and set_up_hermetic_build().
include("${gtest_dir}/cmake/hermetic_build.cmake" OPTIONAL)

if (COMMAND pre_project_set_up_hermetic_build)
  # Google Test also calls hermetic setup functions from add_subdirectory,
  # although its changes will not affect things at the current scope.
  pre_project_set_up_hermetic_build()
endif()

########################################################################
#
# Project-wide settings

# Name of the project.
#
# CMake files in this project can refer to the root source directory
# as ${gmock_SOURCE_DIR} and to the root binary directory as
# ${gmock_BINARY_DIR}.
# Language "C" is required for find_package(Threads).
project(gmock CXX C)
cmake_minimum_required(VERSION 2.6.2)

if (COMMAND set_up_hermetic_build)
  set_up_hermetic_build()
endif()

# Instructs CMake to process Google Test's CMakeLists.txt and add its
# targets to the current scope.  We are placing Google Test's binary
# directory in a subdirectory of our own as VC compilation may break
# if they are the same (the default).
add_subdirectory("${gtest_dir}" "${gmock_BINARY_DIR}/gtest")

# Although Google Test's CMakeLists.txt calls this function, the
# changes there don't affect the current scope.  Therefore we have to
# call it again here.
config_compiler_and_linker()  # from ${gtest_dir}/cmake/internal_utils.cmake

# Adds Google Mock's and Google Test's header directories to the search path.
include_directories("${gmock_SOURCE_DIR}/include"
                    "${gmock_SOURCE_DIR}"
                    "${gtest_SOURCE_DIR}/include"
                    # This directory is needed to build directly from Google
                    # Test sources.
                    "${gtest_SOURCE_DIR}")

# Summary of tuple support for Microsoft Visual Studio:
# Compiler    version(MS)  version(cmake)  Support
# ----------  -----------  --------------  -----------------------------
# <= VS 2010  <= 10        <= 1600         Use Google Tests's own tuple.
# VS 2012     11           1700            std::tr1::tuple + _VARIADIC_MAX=10
# VS 2013     12           1800            std::tr1::tuple
if (MSVC AND MSVC_VERSION EQUAL 1700)
  add_definitions(/D _VARIADIC_MAX=10)
endif()

########################################################################
#
# Defines the gmock & gmock_main libraries.  User tests should link
# with one of them.

# Google Mock libraries.  We build them using more strict warnings than what
# are used for other targets, to ensure that Google Mock can be compiled by
# a user aggressive about warnings.
cxx_library(gmock
            "${cxx_strict}"
            "${gtest_dir}/src/gtest-all.cc"
            src/gmock-all.cc)

cxx_library(gmock_main
            "${cxx_strict}"
            "${gtest_dir}/src/gtest-all.cc"
            src/gmock-all.cc
            src/gmock_main.cc)

########################################################################
#
# Google Mock's own tests.
#
# You can skip this section if you aren't interested in testing
# Google Mock itself.
#
# The tests are not built by default.  To build them, set the
# gmock_build_tests option to ON.  You can do it by running ccmake
# or specifying the -Dgmock_build_tests=ON flag when running cmake.

if (gmock_build_tests)
  # This must be set in the root directory for the tests to be run by
  # 'make test' or ctest.
  enable_testing()

  ############################################################
  # C++ tests built with standard compiler flags.

  cxx_test(gmock-actions_test gmock_main)
  cxx_test(gmock-cardinalities_test gmock_main)
  cxx_test(gmock_ex_test gmock_main)
  cxx_test(gmock-generated-actions_test gmock_main)
  cxx_test(gmock-generated-function-mockers_test gmock_main)
  cxx_test(gmock-generated-internal-utils_test gmock_main)
  cxx_test(gmock-generated-matchers_test gmock_main)
  cxx_test(gmock-internal-utils_test gmock_main)
  cxx_test(gmock-matchers_test gmock_main)
  cxx_test(gmock-more-actions_test gmock_main)
  cxx_test(gmock-nice-strict_test gmock_main)
  cxx_test(gmock-port_test gmock_main)
  cxx_test(gmock-spec-builders_test gmock_main)
  cxx_test(gmock_link_test gmock_main test/gmock_link2_test.cc)
  cxx_test(gmock_test gmock_main)

  if (CMAKE_USE_PTHREADS_INIT)
    cxx_test(gmock_stress_test gmock)
  endif()

  # gmock_all_test is commented to save time building and running tests.
  # Uncomment if necessary.
  # cxx_test(gmock_all_test gmock_main)

  ############################################################
  # C++ tests built with non-standard compiler flags.

  cxx_library(gmock_main_no_exception "${cxx_no_exception}"
    "${gtest_dir}/src/gtest-all.cc" src/gmock-all.cc src/gmock_main.cc)

  cxx_library(gmock_main_no_rtti "${cxx_no_rtti}"
    "${gtest_dir}/src/gtest-all.cc" src/gmock-all.cc src/gmock_main.cc)

  if (NOT MSVC OR MSVC_VERSION LESS 1600)  # 1600 is Visual Studio 2010.
    # Visual Studio 2010, 2012, and 2013 define symbols in std::tr1 that
    # conflict with our own definitions. Therefore using our own tuple does not
    # work on those compilers.
    cxx_library(gmock_main_use_own_tuple "${cxx_use_own_tuple}"
      "${gtest_dir}/src/gtest-all.cc" src/gmock-all.cc src/gmock_main.cc)

    cxx_test_with_flags(gmock_use_own_tuple_test "${cxx_use_own_tuple}"
      gmock_main_use_own_tuple test/gmock-spec-builders_test.cc)
  endif()

  cxx_test_with_flags(gmock-more-actions_no_exception_test "${cxx_no_exception}"
    gmock_main_no_exception test/gmock-more-actions_test.cc)

  cxx_test_with_flags(gmock_no_rtti_test "${cxx_no_rtti}"
    gmock_main_no_rtti test/gmock-spec-builders_test.cc)

  cxx_shared_library(shared_gmock_main "${cxx_default}"
    "${gtest_dir}/src/gtest-all.cc" src/gmock-all.cc src/gmock_main.cc)

  # Tests that a binary can be built with Google Mock as a shared library.  On
  # some system configurations, it may not possible to run the binary without
  # knowing more details about the system configurations. We do not try to run
  # this binary. To get a more robust shared library coverage, configure with
  # -DBUILD_SHARED_LIBS=ON.
  cxx_executable_with_flags(shared_gmock_test_ "${cxx_default}"
    shared_gmock_main test/gmock-spec-builders_test.cc)
  set_target_properties(shared_gmock_test_
    PROPERTIES
    COMPILE_DEFINITIONS "GTEST_LINKED_AS_SHARED_LIBRARY=1")

  ############################################################
  # Python tests.

  cxx_executable(gmock_leak_test_ test gmock_main)
  py_test(gmock_leak_test)

  cxx_executable(gmock_output_test_ test gmock)
  py_test(gmock_output_test)
endif()

=== deps/libneon/src/CMakeLists.txt ===


LIST(APPEND src_neon "ne_207.c" "ne_acl3744.c" "ne_alloc.c" "ne_auth.c" "ne_basic.c" "ne_compress.c" "ne_dates.c" "ne_i18n.c"
                     "ne_locks.c" "ne_md5.c" "ne_ntlm.c" "ne_oldacl.c" "ne_pkcs11.c" "ne_props.c" "ne_redirect.c" "ne_request.c"
                     "ne_session.c" "ne_socket.c" "ne_socks.c" "ne_sspi.c" "ne_string.c" "ne_uri.c" "ne_utils.c"
                     "ne_xml.c" "ne_xmlreq.c")

if(HAVE_OPENSSL)
set(src_ssl "ne_openssl.c")
endif(HAVE_OPENSSL)


if(HAVE_GNUTLS)
set(src_ssl "ne_gnutls.c")
endif(HAVE_GNUTLS)

add_library(neon STATIC ${src_neon} ${src_ssl})

# if the static library is produced, then we need also to install the dependent libraries to be useful
if(STATIC_LIBRARY)
  install(TARGETS neon DESTINATION ${LIB_INSTALL_DIR} )
endif()

=== debian/changelog ===
davix (0.7.5-2build2) focal; urgency=medium

  * No-change rebuild for libgcc-s1 package name change.

 -- Matthias Klose <doko@ubuntu.com>  Tue, 24 Mar 2020 15:13:13 +0100

davix (0.7.5-2build1) focal; urgency=medium

  * Rebuild against new libgsoap-2.8.91.

 -- Gianfranco Costamagna <locutusofborg@debian.org>  Thu, 28 Nov 2019 15:12:13 +0100

davix (0.7.5-2) unstable; urgency=medium

  * Use --with sphinxdoc

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 14 Oct 2019 09:44:24 +0200

davix (0.7.5-1) unstable; urgency=medium

  * Update to version 0.7.5

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 28 Aug 2019 14:15:22 +0200

=== debian/control ===
Source: davix
Priority: optional
Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
Build-Depends:
 debhelper (>= 10),
 cmake,
 libxml2-dev,
 libssl-dev,
 gsoap,
 libgsoap-dev,
 libgtest-dev (>= 1.8.0-7),
 pkg-config,
 doxygen,
 python3-sphinx,
 python3-sphinx-rtd-theme,
 zlib1g-dev,
 uuid-dev,
 rapidjson-dev
Standards-Version: 4.4.1
Section: net
Vcs-Browser: https://salsa.debian.org/ellert/davix
Vcs-Git: https://salsa.debian.org/ellert/davix.git
Homepage: http://dmc.web.cern.ch/projects/davix/home

Package: davix
Architecture: any
Multi-Arch: foreign
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libdavix0v5 (= ${binary:Version})
Description: Toolkit for http based file management
 Davix is a toolkit designed for file operations with http based protocols
 (WebDav, Amazon S3, ...).

Package: davix-tests
Architecture: any
Multi-Arch: foreign
Replaces:
 davix (<< 0.7.1-2~)
Breaks:
 davix (<< 0.7.1-2~)
Depends:
 ${shlibs:Depends},
 ${misc:Depends},
 libdavix0v5 (= ${binary:Version})
Description: Test suite for davix
 Test suite for davix. Davix is a toolkit designed for file operations
 with http based protocols (WebDav, Amazon S3, ...).

Package: libdavix0v5
Section: libs
Architecture: any
Multi-Arch: same
Replaces:
 libdavix0 (<< 0.4.1-2~)
Breaks:
 libdavix0 (<< 0.4.1-2~)
Depends:
 ${shlibs:Depends},
 ${misc:Depends}
Description: Runtime library for davix
 Library for davix. Davix is a toolkit designed for file operations with
 http based protocols (WebDav, Amazon S3, ...).

Package: davix-dev
Section: libdevel
Architecture: any
Multi-Arch: same
Depends:
 ${misc:Depends},
 libdavix0v5 (= ${binary:Version})
Description: Development files for davix
 Development files for davix. Davix is a toolkit designed for file operations
 with http based protocols (WebDav, Amazon S3, ...).

Package: davix-doc
Section: doc
Architecture: all
Multi-Arch: foreign
Depends:
 ${misc:Depends},
 ${sphinxdoc:Depends}
Built-Using:
 ${sphinxdoc:Built-Using}
Description: Documentation for davix
 Documentation and examples for davix. Davix is a toolkit designed for file
 operations with Http based protocols (WebDav, Amazon S3, ...).

=== debian/rules ===
#!/usr/bin/make -f
# -*- makefile -*-

%:
	dh $@ --with sphinxdoc

override_dh_auto_configure:
	# Remove bundled stuff
	rm -rf deps/googletest/googlemock
	rm -rf deps/googletest/googletest/*
	touch deps/googletest/googletest/CMakeLists.txt
	rm -rf deps/strptime
	rm -rf src/libs/rapidjson
	rm -rf test/pywebdav
	rm -rf doc/sphinx/_themes/sphinx_rtd_theme
	# Symlink to system rapidjson
	ln -s /usr/include/rapidjson src/libs/rapidjson
	dh_auto_configure -- -DLIB_SUFFIX="/$(DEB_HOST_MULTIARCH)" \
		-DENABLE_HTML_DOCS=TRUE \
		-DENABLE_THIRD_PARTY_COPY=TRUE

override_dh_auto_build:
	dh_auto_build -- all doc

override_dh_auto_install:
	dh_auto_install
	rm debian/tmp/usr/share/doc/davix/LICENSE

override_dh_missing:
	dh_missing --fail-missing

override_dh_strip:
	dh_strip --dbgsym-migration='davix-dbg (<< 0.6.7), libdavix-dbg (<< 0.6.7)'

override_dh_auto_clean:
	rm -rf src/libs/rapidjson
	rm deps/googletest/googletest/CMakeLists.txt
	dh_auto_clean

override_dh_auto_test:
	dh_auto_test -- ARGS+="-V -T Test"

## davix 0.7.6

=== CMakeLists.txt ===
--- 
+++ 
@@ -40,7 +40,7 @@
 # A bit hacky.
 #-------------------------------------------------------------------------------
 include(${CMAKE_CURRENT_SOURCE_DIR}/release.cmake REQUIRED)
-include(${CMAKE_CURRENT_SOURCE_DIR}/version.cmake)
+include(${CMAKE_CURRENT_SOURCE_DIR}/version.cmake OPTIONAL)
 message("Configuring cmake for davix version: ${VERSION_FULL}")
 
 set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

=== deps/CMakeLists.txt ===
###
## compile dependencies of davix


IF(NOT HAVE_STRPTIME_H)
    SET(SRC_STRPTIME "${CMAKE_CURRENT_SOURCE_DIR}/strptime/strptime.c" PARENT_SCOPE)
ELSE(NOT HAVE_STRPTIME_H)
    SET(SRC_STRPTIME "" PARENT_SCOPE)
ENDIF(NOT HAVE_STRPTIME_H)


SET(SRC_SIMPLE_GET_PASS "${CMAKE_CURRENT_SOURCE_DIR}/simple_getpass/simple_get_pass.cpp" PARENT_SCOPE)
SET(SRC_STRING_UTILS_CPP "${CMAKE_CURRENT_SOURCE_DIR}/string_utils/stringutils.cpp" PARENT_SCOPE)


add_subdirectory(libneon)


if(NOT HAVE_SYS_SOCKET_H)
set(SOCKET_PKG_LIBRARIES "ws2_32")
endif(NOT HAVE_SYS_SOCKET_H)

SET(HTTPLIB_PKG_VERSION "0.29.0" PARENT_SCOPE)
SET(HTTPLIB_PKG_STATIC_LIB_PATH "${CMAKE_CURRENT_BINARY_DIR}/libneon/src/libneon.a")
SET(HTTPLIB_PKG_LIBRARIES ${HTTPLIB_PKG_STATIC_LIB_PATH} ${LIBSSL_PKG_LIBRARIES} ${LIBGSSAPI_PKG_LIBRARIES} ${LIBXML2_LIBRARIES} ${SOCKET_PKG_LIBRARIES} PARENT_SCOPE)
SET(HTTPLIB_PKG_INCLUDE_DIRS ${CMAKE_CURRENT_SOURCE_DIR}/libneon/src/  ${LIBXML2_INCLUDE_DIRS} ${LIBSSL_PKG_INCLUDE_DIRS}  ${LIBGSSAPI_PKG_INCLUDE_DIRS} PARENT_SCOPE)

=== src/CMakeLists.txt ===
# main file for src

set(DAVIX_SOURCES
  auth/davix_openssl.cpp
  auth/davixauth.cpp
  auth/davixx509cred_internal.hpp                        auth/davixx509cred.cpp
  backend/BackendRequest.hpp                             backend/BackendRequest.cpp
  core/RedirectionResolver.hpp                           core/RedirectionResolver.cpp
  core/SessionPool.hpp
                                                         deprecated/httpcachetoken.cpp
                                                         file/davfile.cpp
                                                         file/davposix.cpp
  fileops/azure_meta_ops.hpp
  fileops/AzureIO.hpp                                    fileops/AzureIO.cpp
  fileops/chain_factory.hpp                              fileops/chain_factory.cpp
  fileops/davix_reliability_ops.hpp                      fileops/davix_reliability_ops.cpp
  fileops/davmeta.hpp                                    fileops/davmeta.cpp
  fileops/fileutils.hpp                                  fileops/fileutils.cpp
  fileops/httpiochain.hpp                                fileops/httpiochain.cpp
  fileops/httpiovec.hpp                                  fileops/httpiovec.cpp
  fileops/iobuffmap.hpp                                  fileops/iobuffmap.cpp
  fileops/S3IO.hpp                                       fileops/S3IO.cpp
                                                         hooks/davix_hooks.cpp
  modules/modules_profiles.hpp                           modules/modules_profiles.cpp
  neon/neonrequest.hpp                                   neon/neonrequest.cpp
  neon/neonsession.hpp                                   neon/neonsession.cpp
  neon/neonsessionfactory.hpp                            neon/neonsessionfactory.cpp
                                                         params/davixrequestparams.cpp
                                                         request/httprequest.cpp
                                                         status/davixstatusrequest.cpp
  utils/checksum_extractor.hpp                           utils/checksum_extractor.cpp
                                                         utils/davix_azure_utils.cpp
  utils/davix_fileproperties.hpp
                                                         utils/davix_gcloud_utils.cpp
  utils/davix_logger_internal.hpp                        utils/davix_logger.cpp
                                                         utils/davix_misc_utils.cpp
  utils/davix_utils_internal.hpp                         utils/davix_s3_utils.cpp
                                                         utils/davixuri.cpp
  xml/azurepropparser.hpp                                xml/azurepropparser.cpp
  xml/davdeletexmlparser.hpp                             xml/davdeletexmlparser.cpp
  xml/davix_ptree.hpp                                    xml/davix_ptree.cpp
  xml/davpropxmlparser.hpp                               xml/davpropxmlparser.cpp
  xml/davxmlparser.hpp                                   xml/davxmlparser.cpp
  xml/metalinkparser.hpp                                 xml/metalinkparser.cpp
  xml/s3deleteparser.hpp                                 xml/s3deleteparser.cpp
  xml/S3MultiPartInitiationParser.hpp                    xml/S3MultiPartInitiationParser.cpp
  xml/s3propparser.hpp                                   xml/s3propparser.cpp;

  davixcontext.cpp
)

include_directories("libs" ".")

configure_file(davix_internal_config.in ${CMAKE_CURRENT_BINARY_DIR}/davix_internal_config.hpp @ONLY)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR})
link_directories(${HTTPLIB_PKG_LIBRARY_DIR} ${CRYPTO_PKG_LIBRARY_DIR}
                                        ${LIBXML2_PKG_LIBRARY_DIR} )

add_subdirectory(modules/copy)
add_subdirectory(libs)

if(ENABLE_TOOLS)
  add_subdirectory(tools)
endif()

LIST(APPEND SRC_DAVIX_FULL ${DAVIX_SOURCES} ${src_datetime}
                           ${SRC_STRPTIME} ${SRC_MEMPCPY} ${SRC_STRLCPY} ${SRC_STRING_UTILS_CPP}
                           ${SRC_BASE64} ${SRC_HMACSHA1})


add_definitions(${HTTPLIB_PKG_CFLAGS} )

if(SHARED_LIBRARY)
add_library(libdavix  SHARED ${SRC_DAVIX_FULL} )
add_dependencies(libdavix neon)


target_link_libraries(libdavix  alibxx_core ${HTTPLIB_PKG_LIBRARIES} ${CRYPTO_PKG_LIBRARIES}
                                ${CMAKE_THREAD_LIBS_INIT} ${SOCKET_PKG_LIBRARIES} ${UUID_LIBRARIES})

set_target_properties(libdavix PROPERTIES
                            VERSION ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH}
                            SOVERSION ${VERSION_MAJOR}
                            CLEAN_DIRECT_OUTPUT 1
                            OUTPUT_NAME ${OUTPUT_NAME_DAVIX})

install(TARGETS libdavix
             DESTINATION ${LIB_INSTALL_DIR} )

add_PkgConfigFile_for_Library("davix.pc" libdavix
                               HEADER_DIRS "davix"
                               CFLAGS " -D_FILE_OFFSET_BITS=64 "
                               DESCRIPTION "Libdavix, IO library for HTTP based protocols"
                               )
#install pkgconfig
install(FILES ${CMAKE_CURRENT_BINARY_DIR}/davix.pc
        DESTINATION ${PKGCONFIG_FILES_DIR} )

endif(SHARED_LIBRARY)



if(STATIC_LIBRARY)

add_definitions(-DA_LIB_NAMESPACE=Davix)
FILE(GLOB src_alibxx_static "libs/alibxx/*/*.cpp")
add_library(libdavix_static  STATIC ${SRC_DAVIX_FULL} ${src_alibxx_static})

set_target_properties(libdavix_static PROPERTIES
                            OUTPUT_NAME ${OUTPUT_NAME_DAVIX})


install(TARGETS libdavix_static
             DESTINATION ${LIB_INSTALL_DIR} )

endif(STATIC_LIBRARY)

SET(davix_tool_common_src "${davix_tool_common_src_up}" PARENT_SCOPE)

=== deps/libneon/CMakeLists.txt ===
project(libneon-tuned)
cmake_minimum_required (VERSION 2.6)
# main file for src

set(CMAKE_MODULE_PATH "${CMAKE_SOURCE_DIR}/cmake/modules/")

# load module
include(ReleaseDebugAutoFlags REQUIRED)
include(PortabilityGNUCheck REQUIRED)
set(OUTPUT_NAME_DAVIX "neon")
set(VERSION_MAJOR 0)
set(VERSION_MINOR 0)
set(VERSION_PATCH 29)
set(VERSION_STRING ${VERSION_MAJOR}.${VERSION_MINOR}.${VERSION_PATCH})

find_package(SOCKET)

find_package(LibXml2)
if(LIBXML2_INCLUDE_DIR)
set(HAVE_LIBXML 1)
endif(LIBXML2_INCLUDE_DIR)

set(HAVE_IPV6 ${ENABLE_IPV6})
set(TCP_NODELAY ${ENABLE_TCP_NODELAY})

configure_file(config.cmake.in ${CMAKE_CURRENT_BINARY_DIR}/config.h @ONLY)

include_directories(${CMAKE_CURRENT_SOURCE_DIR} ${CMAKE_CURRENT_BINARY_DIR} ${CMAKE_CURRENT_SOURCE_DIR}/../
                    ${LIBXML2_INCLUDE_DIR} ${OPENSSL_INCLUDE_DIR})

add_definitions(  -std=gnu99 -fPIC -DNEON_VERSION="${VERSION_STRING}" -DNE_VERSION_MAJOR=${VERSION_MAJOR}  -DNE_VERSION_MINOR=${VERSION_MINOR} -Wno-unused-parameter)
add_definitions( -fvisibility=hidden)



add_subdirectory(src)

=== debian/changelog ===
davix (0.7.6-3) unstable; urgency=medium

  * Change to debhelper compat level 13
  * Remove override_dh_missing rule (--fail-missing is default)
  * Update Homepage tag in debian/control (Closes: #977213)

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Mon, 04 Jan 2021 16:00:30 +0100

davix (0.7.6-2) unstable; urgency=medium

  * Update .shlibs file

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Sun, 03 May 2020 10:22:58 +0200

davix (0.7.6-1) unstable; urgency=medium

  * Update to version 0.7.6

 -- Mattias Ellert <mattias.ellert@physics.uu.se>  Wed, 29 Apr 2020 16:31:23 +0200

=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Priority: optional
 Maintainer: Mattias Ellert <mattias.ellert@physics.uu.se>
 Build-Depends:
- debhelper (>= 10),
+ debhelper (>= 13),
  cmake,
  libxml2-dev,
  libssl-dev,
@@ -16,11 +16,11 @@
  zlib1g-dev,
  uuid-dev,
  rapidjson-dev
-Standards-Version: 4.4.1
+Standards-Version: 4.5.1
 Section: net
 Vcs-Browser: https://salsa.debian.org/ellert/davix
 Vcs-Git: https://salsa.debian.org/ellert/davix.git
-Homepage: http://dmc.web.cern.ch/projects/davix/home
+Homepage: https://dmc-docs.web.cern.ch/dmc-docs/davix.html
 
 Package: davix
 Architecture: any
@@ -52,10 +52,6 @@
 Section: libs
 Architecture: any
 Multi-Arch: same
-Replaces:
- libdavix0 (<< 0.4.1-2~)
-Breaks:
- libdavix0 (<< 0.4.1-2~)
 Depends:
  ${shlibs:Depends},
  ${misc:Depends}

=== debian/rules ===
--- 
+++ 
@@ -26,15 +26,12 @@
 	dh_auto_install
 	rm debian/tmp/usr/share/doc/davix/LICENSE
 
-override_dh_missing:
-	dh_missing --fail-missing
-
 override_dh_strip:
 	dh_strip --dbgsym-migration='davix-dbg (<< 0.6.7), libdavix-dbg (<< 0.6.7)'
 
 override_dh_auto_clean:
 	rm -rf src/libs/rapidjson
-	rm deps/googletest/googletest/CMakeLists.txt
+	rm -f deps/googletest/googletest/CMakeLists.txt
 	dh_auto_clean
 
 override_dh_auto_test:
